#!/usr/bin/env python  
# -*- coding: utf-8 -*-    
#
#       addOutputItemsDialog.py
#
#           出力項目を追加する
#
#   15/12/18    新規作成
#      12/25    行末コードlsを修正
#   16/01/06    tresca応力ひずみを追加
#
#

import sys   
import os   
import os.path   
import pygtk
import gtk
import glob
import pyFistr

#ls = os.linesep
ls = "\n"
outItems = []


def getOutputFlag():
    windowApp()  
    gtk.main()
    return outItems


class windowApp:  
    def __init__(self):

        #windows版のpangoWarning対策で以下の3行を追加。
        #　easyIstr_1.gladeを読み込む処理を追加
        gladefile = "easyIstr_1.glade"  
        self.builder = gtk.Builder()  
        self.builder.add_from_file(os.getenv("easyIstrPath") + os.sep + gladefile)

        #Set the Glade file
        gladefile = "addOutputItemsDialog_1.glade"  
        self.builder = gtk.Builder()  
        self.builder.add_from_file(os.path.dirname(os.path.abspath(__file__)) +
                os.sep + gladefile)  

        self.setGtkObject()
        self.subInitialize()

        #windowを表示
        self.builder.connect_signals(self)
        self.mainWindow = self.builder.get_object ("window3")
        title = _(u"出力項目を追加")
        self.mainWindow.set_title(title)
        self.mainWindow.show_all()

    #
    #  setGtkObject
    #    objectの定義
    def setGtkObject(self):
        self.checkBtn_misesStress = self.builder.get_object("checkbutton1")
        self.checkBtn_sigma = self.builder.get_object("checkbutton2")
        self.checkBtn_sigmaVec = self.builder.get_object("checkbutton3")
        self.checkBtn_misesStrain = self.builder.get_object("checkbutton4")
        self.checkBtn_epsilon = self.builder.get_object("checkbutton5")
        self.checkBtn_epsilonVec = self.builder.get_object("checkbutton6")
        self.checkBtn_trescaStress = self.builder.get_object("checkbutton7")
        self.checkBtn_trescaStrain = self.builder.get_object("checkbutton8")

    #
    #  subInitialize
    #    初期化
    def subInitialize(self):
        addFlag = readAddFlag()
        self.setCheckBtn(addFlag)
        return


    #追加
    def onAddItems(self, event):
        outItems = self.addItems(event)
        saveAddFlag(outItems)
        flag = " ".join(outItems)
        comm = "addPrincipalStressWithDialog.py " + flag
        pyFistr.runAppBG(comm)
        gtk.main_quit()

    #キャンセル
    def onCancel(self, event):
        gtk.main_quit()


    #
    #  addItems
    #    出力項目を読み取り、項目を追加する。
    def addItems(self, event):

        def getFlag(flag):
            ans = "0"
            if flag == True:
                ans = "1"
            return ans

        outItems = []
        outItems.append(getFlag(self.checkBtn_misesStress.get_active()))
        outItems.append(getFlag(self.checkBtn_sigma.get_active()))
        outItems.append(getFlag(self.checkBtn_sigmaVec.get_active()))
        outItems.append(getFlag(self.checkBtn_misesStrain.get_active()))
        outItems.append(getFlag(self.checkBtn_epsilon.get_active()))
        outItems.append(getFlag(self.checkBtn_epsilonVec.get_active()))
        outItems.append(getFlag(self.checkBtn_trescaStress.get_active()))
        outItems.append(getFlag(self.checkBtn_trescaStrain.get_active()))
        return outItems

    #
    #  setCheckBtn
    #    checkBtnをセット
    def setCheckBtn(self, addFlag):
        #応力
        if addFlag[0] == "0":
            self.checkBtn_misesStress.set_active(False)
        else:
            self.checkBtn_misesStress.set_active(True)
        if addFlag[1] == "0":
            self.checkBtn_sigma.set_active(False)
        else:
            self.checkBtn_sigma.set_active(True)
        if addFlag[2] == "0":
            self.checkBtn_sigmaVec.set_active(False)
        else:
            self.checkBtn_sigmaVec.set_active(True)
        if addFlag[6] == "0":
            self.checkBtn_trescaStress.set_active(False)
        else:
            self.checkBtn_trescaStress.set_active(True)
        #ひずみ
        if addFlag[3] == "0":
            self.checkBtn_misesStrain.set_active(False)
        else:
            self.checkBtn_misesStrain.set_active(True)
        if addFlag[4] == "0":
            self.checkBtn_epsilon.set_active(False)
        else:
            self.checkBtn_epsilon.set_active(True)
        if addFlag[5] == "0":
            self.checkBtn_epsilonVec.set_active(False)
        else:
            self.checkBtn_epsilonVec.set_active(True)
        if addFlag[7] == "0":
            self.checkBtn_trescaStrain.set_active(False)
        else:
            self.checkBtn_trescaStrain.set_active(True)

#
#  readAddFlag
#    追加する項目をfileから読み込み
def readAddFlag():
    fileName = os.getenv("easyIstrUserPath")+os.sep+"data"+os.sep+"easyIstr_data"
    addFlag = ["0", "1", "0", "0", "0", "0", "0", "0"]
    if len(glob.glob(fileName)) != 0:
        f=open(fileName); lines=f.readlines(); f.close()
        for line in lines:
            words = line.split()
            if len(words) > 1:
                if words[0] == "addFlag":
                    for i in range(len(words[1:])):
                        flag = words[i+1]
                        addFlag[i] = flag
    return addFlag

#
#  saveAddFlag
#    addFlagを書き込み
def saveAddFlag(addFlag):
    addLine = "addFlag " + " ".join(addFlag)
    fileName = os.getenv("easyIstrUserPath")+os.sep+"data"+os.sep+"easyIstr_data"
    if len(glob.glob(fileName)) == 0:
        cont = "addOutputItems" + ls + addLine + ls
        f=open(fileName, "w"); f.write(cont); f.close()
    else:
        f=open(fileName); lines=f.readlines(); f.close()
        flag = 0
        for i in range(len(lines)):
            line = lines[i]
            words = line.split()
            if len(words) > 1:
                if words[0] == "addFlag":
                    lines[i] = addLine + "\n"
                    flag = 1
                    break
        if flag == 0:
            lines += ["addOutputItems\n"]
            lines += [addLine + "\n"]
        f=open(fileName, "w")
        for line in lines:
            f.write(line)
        f.close()


if __name__ == "__main__":  
    import gettext
    gettext.install("app") # replace with the appropriate catalog name

    windowApp()  
    gtk.main()
    
